//SLIME 2.0
//Mark Leich and Chris Pieprzak

// INCLUDES ///////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN  

#define INITGUID // if not done elsewhere

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <objbase.h>
#include <iostream> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>

#include <ddraw.h>  // directX includes
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include <dinput.h>

#include "T3DLIB1.H"//Always include these
#include "T3DLIB2.H"
#include "T3DLIB3.H"

// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINCLASS1"

// setup a 640x480 16-bit windowed mode example
#define WINDOW_TITLE      "16-Bit Keyboard Demo"
#define WINDOW_WIDTH      640   // size of window
#define WINDOW_HEIGHT     480

#define WINDOW_BPP        16    

#define WINDOWED_APP      0     // 0 not windowed, 1 windowed

// slime directions

#define SLIME_EAST         0 
#define SLIME_NORTH        1
#define SLIME_WEST         2
#define SLIME_SOUTH        3
#define SLIME_AEAST		  4
#define SLIME_ANORTH		  5
#define SLIME_AWEST		  6
#define SLIME_ASOUTH		  7
#define SLIME_SEAST         8 
#define SLIME_SNORTH        9
#define SLIME_SWEST         10
#define SLIME_SSOUTH        11

//These set up conditions for playing music
//I'll explain later
int IsIntro = 1;
int IsStory = 0;
int IsStory2 = 0;
int IsStory3 = 0;
int IsDeath = 0;
int IsEnding = 0;
int monsters_killed = 0;

//STUFF THAT IS SWEET

int room = 4;
bool firstTime = true; //used to setup a room when entered
bool aliveFlag[16][3][100]; //[room number][type of monster][number of monster] true for alive false for dead
DWORD attackCount;	//used to release the player from attack position after so many clicks
DWORD playerHitCount;  //used to make the player invalnerable after being hit.
DWORD linkHitCount;		//used to make link invalnerable after being hit (prevents him from dying too quickly if link_AI runs multiply times during one attack
bool notHit = true;
int linkHealth = 10;
bool linkNotHit = true;
bool loadRoom13b = true;

// TYPES ///////////////////////////////////////////////////


// PROTOTYPES /////////////////////////////////////////////

// game console
int Game_Init(void *parms=NULL, int num_parms = 0);
int Game_Shutdown(void *parms=NULL, int num_parms = 0);
int Game_Main(void *parms=NULL,  int num_parms = 0);

int Load_Sound_Music(void);
// GLOBALS ////////////////////////////////////////////////

// windows vars
HWND      main_window_handle = NULL; // globally track main window
int       window_closed      = 0;    // tracks if window is closed
HINSTANCE main_instance      = NULL; // globally track hinstance

char buffer[80];                // used to print text


// demo globals
BOB          slime;     // the player slime

/*
Here is where you declare all different animation groups.
This is what frames go into which direction the BOB is facing
You need a two-dimentional array for any BOB that faces in more than one
direction. The first value (rows) is how many directions you need (in my case, 4),
and second value (columns) is how many frames there is to the animations.
Then you define which frames are used in what order.
Simple.
Oh, before I forget, the additions made to each row are needed because
2-dimentional arrays are just longer 1-dimamentional arrays, and you're loading
images into it in different spots. Just remember to add the first value (rows)
to next column.
Like I said, simple.
*/
// animation sequences for bob
int slime_stand[4][1] = { {0},
							{0+4},
							{0+8},
							{0+12}, };

int slime_walk[4][4] = { {0,1,0,2},
                             {0+4,1+4,0+4,2+4},
                             {0+8,1+8,0+8,2+8},
							{0+12,1+12,0+12,2+12}, };
                           
int slime_attack[4][1] = { {3},
							{3+4},
							{3+8},
							{3+12}, };
//My weapon changes shape, I guess I could have just rotated one,
//but hindsight is always 20/20
BOB          weaponeast;       // players weapon
BOB			 weaponwest;
BOB			 weaponnorth;
BOB			 weaponsouth;

/*
Now, for any BOB that you want more of, but is exactly the same,
you can make an array of BOBs, again, very simple.
However, remember that you are dealing with an array, so looping is required
*/
const int MAX_GUARDS = 10;
BOB				guard[MAX_GUARDS];
int guard_walk[4][4] = { {0,1,0,2},
                             {0+4,1+4,0+4,2+4},
                             {0+8,1+8,0+8,2+8},
							{0+12,1+12,0+12,2+12}, };
int guard_speed = 2;
int guard_active[MAX_GUARDS];

BOB link;
int link_walk[4][4] = { {0,1,0,2},
                             {0+4,1+4,0+4,2+4},
                             {0+8,1+8,0+8,2+8},
							{0+12,1+12,0+12,2+12}, };
int link_speed = 2;
int link_active;


int health = 100;
int keys = 0;

//background images are the simplest things to load, so feel free to load
//in as many as you want.
BITMAP_IMAGE r1;      
BITMAP_IMAGE r2;
BITMAP_IMAGE r3;
BITMAP_IMAGE r4;
BITMAP_IMAGE r5;
BITMAP_IMAGE r6;
BITMAP_IMAGE r7;
BITMAP_IMAGE r8;
BITMAP_IMAGE r9;
BITMAP_IMAGE r10;
BITMAP_IMAGE r11;
BITMAP_IMAGE r12;
BITMAP_IMAGE r13;
BITMAP_IMAGE r14;
BITMAP_IMAGE r15;
BITMAP_IMAGE intro;
BITMAP_IMAGE story;
BITMAP_IMAGE story2;
BITMAP_IMAGE story3;
BITMAP_IMAGE ending;
BITMAP_IMAGE death;

PALETTEENTRY         game_palette[256]; // holds the main game palette
PALETTEENTRY         menu_palette[256]; // gee what do you think

//this is for music, again, I'll explain later
int intro_music_id;
int lvl1_music_id;
int lvl2_music_id;
int story2_music_id;
int story3_music_id;
int win_music_id;
int death_music_id;
int slime_hit_id;
int slime_attack_id;
int guard_die_id;
//Ah, these are control flags that determine when a MIDI is played
int intro_played = 1;
int lvl1_played = 0;
int lvl2_played = 0;
int win_played = 0;
int death_played = 0;
// PROTOTYPES //////////////////////////////////////////////
//Unless you're doing a windowed game, you can just ignore
//this part.
LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT		ps;		// used in WM_PAINT
HDC				hdc;	// handle to a device context
char buffer[80];        // used to print strings

// what is the message 
switch(msg)
	{	
	case WM_CREATE: 
        {
		// do initialization stuff here
        // return success
		return(0);
		} break;
   
	case WM_PAINT: 
		{
		// simply validate the window 
   	    hdc = BeginPaint(hwnd,&ps);	 
        
        // end painting
        EndPaint(hwnd,&ps);

        // return success
		return(0);
   		} break;

	case WM_DESTROY: 
		{

		// kill the application, this sends a WM_QUIT message 
		PostQuitMessage(0);

        // return success
		return(0);
		} break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////
//Blah Blah Blah, keep ignoring.
int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{

WNDCLASSEX winclass; // this will hold the class we create
HWND	   hwnd;	 // generic window handle
MSG		   msg;		 // generic message
HDC        hdc;      // graphics device context

// first fill in the window class stucture
winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

// save hinstance in global
main_instance = hinstance;

// register the window class
if (!RegisterClassEx(&winclass))
	return(0);

// create the window
if (!(hwnd = CreateWindowEx(NULL,                  // extended style
                            WINDOW_CLASS_NAME,     // class
						    WINDOW_TITLE, // title
						    (WINDOWED_APP ? (WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION) : (WS_POPUP | WS_VISIBLE)), 
					 	    0,0,	  // initial x,y
						    WINDOW_WIDTH,WINDOW_HEIGHT,  // initial width, height
						    NULL,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))	// extra creation parms
return(0);

// save main window handle
main_window_handle = hwnd;

if (WINDOWED_APP)
{
// now resize the window, so the client area is the actual size requested
// since there may be borders and controls if this is going to be a windowed app
// if the app is not windowed then it won't matter
RECT window_rect = {0,0,WINDOW_WIDTH-1,WINDOW_HEIGHT-1};

// make the call to adjust window_rect
AdjustWindowRectEx(&window_rect,
     GetWindowStyle(main_window_handle),
     GetMenu(main_window_handle) != NULL,
     GetWindowExStyle(main_window_handle));

// save the global client offsets, they are needed in DDraw_Flip()
window_client_x0 = -window_rect.left;
window_client_y0 = -window_rect.top;

// now resize the window with a call to MoveWindow()
MoveWindow(main_window_handle,
           0, // x position
           0, // y position
           window_rect.right - window_rect.left, // width
           window_rect.bottom - window_rect.top, // height
           TRUE);

// show the window, so there's no garbage on first render
ShowWindow(main_window_handle, SW_SHOW);
} // end if windowed

//Keep going. Thank God for LeMothe doing this for us.

// initialize game here
Game_Init();

// enter main event loop
while(TRUE)
	{
    // test if there is a message in queue, if so get it
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   { 
	   // test if this is a quit
       if (msg.message == WM_QUIT)
           break;
	
	   // translate any accelerator keys
	   TranslateMessage(&msg);

	   // send the message to the window proc
	   DispatchMessage(&msg);
	   } // end if
    
       // main game processing goes here
       Game_Main();
       
	} // end while

// closedown game here
Game_Shutdown();

// return to Windows like this
return(msg.wParam);

} // end WinMain



int Game_Init(void *parms,  int num_parms)
{
// this function is where you do all the initialization 
// for your game

int index;         // looping var
char filename[80]; // used to build up files names

// start up DirectDraw (replace the parms as you desire)
DDraw_Init(WINDOW_WIDTH, WINDOW_HEIGHT, WINDOW_BPP, WINDOWED_APP);
DSound_Init();

slime_hit_id = DSound_Load_WAV("DEBUG/squish.WAV");

DSound_Set_Volume(slime_hit_id, 75);

slime_attack_id = DSound_Load_WAV("DEBUG/SWING.WAV");

guard_die_id = DSound_Load_WAV("DEBUG/punch.WAV");


DMusic_Init();

intro_music_id = DMusic_Load_MIDI("DEBUG/intro.mid");

lvl1_music_id = DMusic_Load_MIDI("DEBUG/lvl1.MID");

lvl2_music_id = DMusic_Load_MIDI("DEBUG/lvl2.MID");

story2_music_id = DMusic_Load_MIDI("DEBUG/story2.MID");

story3_music_id = DMusic_Load_MIDI("DEBUG/tr.MID");

win_music_id = DMusic_Load_MIDI("DEBUG/win.MID");

death_music_id = DMusic_Load_MIDI("DEBUG/death.MID");


#if 0 // directinput7 method
// first create the direct input object
if (DirectInputCreateEx(main_instance,DIRECTINPUT_VERSION,IID_IDirectInput7, (void **)&lpdi,NULL)!=DI_OK)
   return(0);

// create a keyboard device  //////////////////////////////////
if (lpdi->CreateDeviceEx(GUID_SysKeyboard, IID_IDirectInputDevice7, (void **)&lpdikey, NULL)!=DI_OK)
   return(0);
#endif

// first create the direct input object
if (DirectInput8Create(main_instance,DIRECTINPUT_VERSION,IID_IDirectInput8, (void **)&lpdi,NULL)!=DI_OK)
   return(0);

// create a keyboard device  //////////////////////////////////
if (lpdi->CreateDevice(GUID_SysKeyboard, &lpdikey, NULL)!=DI_OK)
   return(0);


// set cooperation level
if (lpdikey->SetCooperativeLevel(main_window_handle, 
                 DISCL_NONEXCLUSIVE | DISCL_BACKGROUND)!=DI_OK)
    return(0);

// set data format
if (lpdikey->SetDataFormat(&c_dfDIKeyboard)!=DI_OK)
   return(0);

// acquire the keyboard
if (lpdikey->Acquire()!=DI_OK)
   return(0);



///////////////////////////////////////////////////////////

int direction;

Load_Bitmap_File(&bitmap16bit, "DEBUG/INTRO.BMP");
Create_Bitmap(&intro, 0,0, 640, 480,16);
Load_Image_Bitmap16(&intro,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

Load_Bitmap_File(&bitmap16bit, "DEBUG/STORY.BMP");
Create_Bitmap(&story, 0,0, 640, 480,16);
Load_Image_Bitmap16(&story,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

Load_Bitmap_File(&bitmap16bit, "DEBUG/STORY2.BMP");
Create_Bitmap(&story2, 0,0, 640, 480,16);
Load_Image_Bitmap16(&story2,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

Load_Bitmap_File(&bitmap16bit, "DEBUG/STORY3.BMP");
Create_Bitmap(&story3, 0,0, 640, 480,16);
Load_Image_Bitmap16(&story3,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

Load_Bitmap_File(&bitmap16bit, "DEBUG/WIN.BMP");
Create_Bitmap(&ending, 0,0, 640, 480,16);
Load_Image_Bitmap16(&ending,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

Load_Bitmap_File(&bitmap16bit, "DEBUG/DEATH.BMP");
Create_Bitmap(&death, 0,0, 640, 480,16);
Load_Image_Bitmap16(&death,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);


//LEVEL 1 is room 1 - room 6
// load room 1
Load_Bitmap_File(&bitmap16bit, "DEBUG/1/1.BMP");
Create_Bitmap(&r1, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r1,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);


// load room 2
Load_Bitmap_File(&bitmap16bit, "DEBUG/1/2.BMP");
Create_Bitmap(&r2, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r2,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

// load room 3
Load_Bitmap_File(&bitmap16bit, "DEBUG/1/3.BMP");
Create_Bitmap(&r3, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r3,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

// load room 4
Load_Bitmap_File(&bitmap16bit, "DEBUG/1/4.BMP");
Create_Bitmap(&r4, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r4,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

// load room 5
Load_Bitmap_File(&bitmap16bit, "DEBUG/1/5.BMP");
Create_Bitmap(&r5, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r5,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

// load room 6
Load_Bitmap_File(&bitmap16bit, "DEBUG/1/6.BMP");
Create_Bitmap(&r6, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r6,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

//LEVEL 2 is room 7 - 14
// load room 7
Load_Bitmap_File(&bitmap16bit, "DEBUG/2/7.BMP");
Create_Bitmap(&r7, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r7,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

// load room 8
Load_Bitmap_File(&bitmap16bit, "DEBUG/2/8.BMP");
Create_Bitmap(&r8, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r8,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

// load room 9
Load_Bitmap_File(&bitmap16bit, "DEBUG/2/9.BMP");
Create_Bitmap(&r9, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r9,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

// load room 10
Load_Bitmap_File(&bitmap16bit, "DEBUG/2/10.BMP");
Create_Bitmap(&r10, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r10,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

// load room 11
Load_Bitmap_File(&bitmap16bit, "DEBUG/2/11.BMP");
Create_Bitmap(&r11, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r11,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

// load room 12
Load_Bitmap_File(&bitmap16bit, "DEBUG/2/12.BMP");
Create_Bitmap(&r12, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r12,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

// load room 13
Load_Bitmap_File(&bitmap16bit, "DEBUG/2/13.BMP");
Create_Bitmap(&r13, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r13,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

// load room 14
Load_Bitmap_File(&bitmap16bit, "DEBUG/2/14.BMP");
Create_Bitmap(&r14, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r14,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);

// load room 15
Load_Bitmap_File(&bitmap16bit, "DEBUG/2/ThrownRoom.bmp");
Create_Bitmap(&r15, 0,0, 640, 480,16);
Load_Image_Bitmap16(&r15,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap16bit);


// create slime bob
if (!Create_BOB(&slime,0,0,64,64,40,
           BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY,0,16))
   return(0);

for (direction = 0; direction < 4; direction++)
    { 
    // build up file name
    sprintf(filename,"DEBUG/SKELSP%d_24.BMP",direction);

    // load in new bitmap file
    Load_Bitmap_File(&bitmap16bit,filename);
	
    Load_Frame_BOB16(&slime,&bitmap16bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB16(&slime,&bitmap16bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB16(&slime,&bitmap16bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB16(&slime,&bitmap16bit,3+direction*4,3,0,BITMAP_EXTRACT_MODE_CELL);  

    // unload the bitmap file
   Unload_Bitmap_File(&bitmap16bit);
	
    Load_Animation_BOB(&slime,direction,4,slime_walk[direction]);
	Load_Animation_BOB(&slime,direction+4,1,slime_attack[direction]);
	Load_Animation_BOB(&slime,direction+8,1,slime_stand[direction]);

    } // end for direction


Set_Animation_BOB(&slime,SLIME_WEST);
Set_Anim_Speed_BOB(&slime, 4);
Set_Vel_BOB(&slime, 0,0);
Set_Pos_BOB(&slime, 500, 300);


Load_Bitmap_File(&bitmap16bit, "DEBUG/WEAPONRIGHT.BMP");
Create_BOB(&weaponeast,0,0,30,16,1,BOB_ATTR_SINGLE_FRAME, DDSCAPS_SYSTEMMEMORY,0,16);
Load_Frame_BOB16(&weaponeast,&bitmap16bit,0,0,0,BITMAP_EXTRACT_MODE_CELL);
Unload_Bitmap_File(&bitmap16bit);

Load_Bitmap_File(&bitmap16bit, "DEBUG/WEAPONLEFT.BMP");
Create_BOB(&weaponwest,0,0,30,16,1,BOB_ATTR_SINGLE_FRAME, DDSCAPS_SYSTEMMEMORY,0,16);
Load_Frame_BOB16(&weaponwest,&bitmap16bit,0,0,0,BITMAP_EXTRACT_MODE_CELL);

Load_Bitmap_File(&bitmap16bit, "DEBUG/WEAPONUP.BMP");
Create_BOB(&weaponnorth,0,0,5,33,1,BOB_ATTR_SINGLE_FRAME, DDSCAPS_SYSTEMMEMORY,0,16);
Load_Frame_BOB16(&weaponnorth,&bitmap16bit,0,0,0,BITMAP_EXTRACT_MODE_CELL);
Unload_Bitmap_File(&bitmap16bit);

Load_Bitmap_File(&bitmap16bit, "DEBUG/WEAPONDOWN.BMP");
Create_BOB(&weaponsouth,0,0,5,33,1,BOB_ATTR_SINGLE_FRAME, DDSCAPS_SYSTEMMEMORY,0,16);
Load_Frame_BOB16(&weaponsouth,&bitmap16bit,0,0,0,BITMAP_EXTRACT_MODE_CELL);
Unload_Bitmap_File(&bitmap16bit);

Set_Anim_Speed_BOB(&weaponeast, 10);
Set_Anim_Speed_BOB(&weaponwest, 10);
Set_Anim_Speed_BOB(&weaponnorth, 10);
Set_Anim_Speed_BOB(&weaponsouth, 10);



for (index = 0; index < MAX_GUARDS; index++)
{
	if (!Create_BOB(&guard[index],0,0, 64,64, 16, 
					BOB_ATTR_MULTI_ANIM | BOB_ATTR_VISIBLE, DDSCAPS_SYSTEMMEMORY,0,16))
	{
					return 0;
	}
	for (direction = 0; direction < 4; direction++)
	{
		sprintf(filename,"DEBUG/Gaurdsp%d_24.bmp",direction);

		Load_Bitmap_File(&bitmap16bit, filename);

		Load_Frame_BOB16(&guard[index],&bitmap16bit,0+direction*4, 0,0,BITMAP_EXTRACT_MODE_CELL);
		Load_Frame_BOB16(&guard[index],&bitmap16bit,1+direction*4, 1,0,BITMAP_EXTRACT_MODE_CELL);
		Load_Frame_BOB16(&guard[index],&bitmap16bit,2+direction*4, 2,0,BITMAP_EXTRACT_MODE_CELL);
		Load_Frame_BOB16(&guard[index],&bitmap16bit,3+direction*4, 3,0,BITMAP_EXTRACT_MODE_CELL);

		Load_Animation_BOB(&guard[index],direction,4,guard_walk[direction]);
	}
	Set_Animation_BOB(&guard[index],(rand()*100)%2);
	Set_Anim_Speed_BOB(&guard[index], 4);
	Set_Vel_BOB(&guard[index], 0,0);
	Set_Pos_BOB(&guard[index], -100, -100);
	guard_active[index] = 0;
}

Unload_Bitmap_File(&bitmap16bit);


	if (!Create_BOB(&link,0,0, 64,64, 16, 
					BOB_ATTR_MULTI_ANIM | BOB_ATTR_VISIBLE, DDSCAPS_SYSTEMMEMORY,0,16))
	{
					return 0;
	}
	for (direction = 0; direction < 4; direction++)
	{
		sprintf(filename,"DEBUG/Linksp%d_24.bmp",direction);

		Load_Bitmap_File(&bitmap16bit, filename);

		Load_Frame_BOB16(&link,&bitmap16bit,0+direction*4, 0,0,BITMAP_EXTRACT_MODE_CELL);
		Load_Frame_BOB16(&link,&bitmap16bit,1+direction*4, 1,0,BITMAP_EXTRACT_MODE_CELL);
		Load_Frame_BOB16(&link,&bitmap16bit,2+direction*4, 2,0,BITMAP_EXTRACT_MODE_CELL);
		Load_Frame_BOB16(&link,&bitmap16bit,3+direction*4, 3,0,BITMAP_EXTRACT_MODE_CELL);

		Load_Animation_BOB(&link,direction,4,guard_walk[direction]);
	}
	Set_Animation_BOB(&link,0);
	Set_Anim_Speed_BOB(&link, 4);
	Set_Vel_BOB(&link, 0,0);
	Set_Pos_BOB(&link, -100, -100);
	link_active = 0;

Unload_Bitmap_File(&bitmap16bit);

//Set up alive array. This will determine how many of what enemy is allowed in each room
//It will also be used to prevent the respawn of monsters.

for(int i = 0; i < 15; i++)
	for(int j = 0; j < 3; j++)
		for(int k = 0; k < 100; k++)
			aliveFlag[i][j][k] = true;

// hide the mouse
if (!WINDOWED_APP)
    ShowCursor(FALSE);

// return success
return(1);

} // end Game_Init

///////////////////////////////////////////////////////////

int Game_Shutdown(void *parms,  int num_parms)
{
	int index;
// this function is where you shutdown your game and
// release all resources that you allocated


Destroy_Bitmap(&r1);
Destroy_Bitmap(&r2);
Destroy_Bitmap(&r3);
Destroy_Bitmap(&r4);
Destroy_Bitmap(&r5);
Destroy_Bitmap(&r6);
Destroy_Bitmap(&r7);
Destroy_Bitmap(&r8);
Destroy_Bitmap(&r9);
Destroy_Bitmap(&r10);
Destroy_Bitmap(&r11);
Destroy_Bitmap(&r12);
Destroy_Bitmap(&r13);
Destroy_Bitmap(&r14);
Destroy_Bitmap(&r15);
Destroy_Bitmap(&intro);
Destroy_Bitmap(&story);
Destroy_Bitmap(&story2);
Destroy_Bitmap(&story3);
Destroy_Bitmap(&ending);
Destroy_Bitmap(&death);
// kill slime
Destroy_BOB(&slime);

Destroy_BOB(&weaponeast);
Destroy_BOB(&weaponwest);
Destroy_BOB(&weaponnorth);
Destroy_BOB(&weaponsouth);

for (index = 0; index < MAX_GUARDS; index++)
	Destroy_BOB(&guard[index]);
Destroy_BOB(&link);

// release keyboard
lpdikey->Unacquire();
lpdikey->Release();
lpdi->Release();

// shutdonw directdraw
DDraw_Shutdown();

DSound_Stop_All_Sounds();
DSound_Shutdown();

DMusic_Delete_All_MIDI();

// shutdown directmusic
DMusic_Shutdown();

// return success
return(1);
} // end Game_Shutdown


void guard_AI(void)
{
	int dx = 0;
	int dy = 0;
	int index;
	for(int total = 0; total < MAX_GUARDS; total++)
	{
	if(guard_active[total] == 1)
	{
		
		if((rand()*Get_Clock())%2 == 0)
		{
			if (slime.x > (guard[total].x + 4))
			{
				if (guard[total].curr_animation != 0)
					Set_Animation_BOB(&guard[total],0);

				//Move guard East
				if(!Collision_BOBS(&guard[total],&slime))
				{
					guard[total].x+=guard_speed;
					dx = guard_speed; 
					dy = 0;
				}
			}
			else if (slime.x < (guard[total].x - 4))
			{
				if (guard[total].curr_animation != 2)
					Set_Animation_BOB(&guard[total],2);

				//Move guard West
				if(!Collision_BOBS(&guard[total],&slime))
				{
					guard[total].x-=guard_speed;	
					dx = -guard_speed; 
					dy = 0;
				}
			}
			else if (slime.y > guard[total].y)
			{
				if (guard[total].curr_animation != 3)
					Set_Animation_BOB(&guard[total],3);

				//Move guard South
				if(!Collision_BOBS(&guard[total],&slime))
				{
					guard[total].y+=guard_speed;
					dx = 0; 
					dy = guard_speed;
				}
			}
			else if (slime.y < guard[total].y)
			{
				if (guard[total].curr_animation != 1)
					Set_Animation_BOB(&guard[total],1);

				//Move guard North
				if(!Collision_BOBS(&guard[total],&slime))
				{
					guard[total].y-=guard_speed;
					dx = 0; 
					dy = -guard_speed;
				}
			}
		}
		else
		{
			if (slime.y > guard[total].y)
			{
				if(!Collision_BOBS(&guard[total],&slime))
				{
					guard[total].y+=guard_speed;
					dx = 0; 
					dy = guard_speed;
				}
			}
			else if (slime.y < guard[total].y)
			{
				if(!Collision_BOBS(&guard[total],&slime))
				{
					guard[total].y-=guard_speed;
					dx = 0; 
					dy = -guard_speed;
				}
			}
			else if (slime.x > guard[total].x)
			{
				if(!Collision_BOBS(&guard[total],&slime))
				{
					guard[total].x+=guard_speed;
					dx = guard_speed; 
					dy = 0;
				}
			}
			else if (slime.x < guard[total].x)
			{
				if(!Collision_BOBS(&guard[total],&slime))
				{
					guard[total].x-=guard_speed;
					dx = -guard_speed; 
					dy = 0;
				}	
			}	
		}
		for(int index = 0; index < MAX_GUARDS; index++)
		{
			if(Collision_BOBS(&guard[total],&guard[index]) && total != index)
			{
				guard[total].x-=dx;
				guard[total].y-=dy;
			}
		}
		
		if(Collision_BOBS(&weaponeast,&guard[total]))
		{
			guard_active[total] = 0;
			Set_Pos_BOB(&guard[total], -100,-100);
			monsters_killed++;
			DSound_Play(guard_die_id, 0);
			aliveFlag[room][0][total] = false;
		}
		if(Collision_BOBS(&weaponwest,&guard[total]))
		{
			guard_active[total] = 0;
			Set_Pos_BOB(&guard[total], -100,-100);
			monsters_killed++;
			DSound_Play(guard_die_id, 0);
			aliveFlag[room][0][total] = false;
		}
		if(Collision_BOBS(&weaponnorth,&guard[total]))
		{
			guard_active[total] = 0;
			Set_Pos_BOB(&guard[total], -100,-100);
			monsters_killed++;
			DSound_Play(guard_die_id, 0);
			aliveFlag[room][0][total] = false;
		}
		if(Collision_BOBS(&weaponsouth,&guard[total]))
		{
			guard_active[total] = 0;
			Set_Pos_BOB(&guard[total], -100,-100);
			monsters_killed++;
			DSound_Play(guard_die_id, 0);
			aliveFlag[room][0][total] = false;
		}
		Animate_BOB(&guard[total]);

		DDraw_Lock_Back_Surface();
			if (Color_Scan16(guard[total].x+16, guard[total].y+16,
                    guard[total].x+guard[total].width-16, guard[total].y+guard[total].height-3,                                    
                    RGB16Bit(1, 1, 1),
                    RGB16Bit(1, 1, 1), back_buffer,back_lpitch))
      {
      // back the guard up along its last trajectory
		  guard[total].x = guard[total].x - dx;
		  guard[total].y = guard[total].y - dy;
      } // end if
		DDraw_Unlock_Back_Surface();
		Draw_BOB16(&guard[total], lpddsback);
	}
	}
}


void link_AI(void)
{
	int dx = 0;
	int dy = 0;
	int index;
	bool linkHit = false;
	if(link_active == 1)
	{	
		if(linkHealth == 5)
		{
			link_speed = 4;
		}
		else if(linkHealth == 2)
		{
			link_speed = 10;
		}
		if((rand()*Get_Clock())%2 == 0)
		{
			if (slime.x > (link.x + 4))
			{
				if (link.curr_animation != 0)
					Set_Animation_BOB(&link,0);

				//Move link East
				if(!Collision_BOBS(&slime,&link))
				{
					link.x+=link_speed;
					dx = link_speed; 
					dy = 0;
				}
			}
			else if (slime.x < (link.x - 4))
			{
				if (link.curr_animation != 2)
					Set_Animation_BOB(&link,2);

				//Move link West
				if(!Collision_BOBS(&slime,&link))
				{
					link.x-=link_speed;	
					dx = -link_speed; 
					dy = 0;
				}
			}
			else if (slime.y > link.y)
			{
				if (link.curr_animation != 3)
					Set_Animation_BOB(&link,3);

				//Move link South
				if(!Collision_BOBS(&slime,&link))
				{
					link.y+=link_speed;
					dx = 0; 
					dy = link_speed;
				}
			}
			else if (slime.y < link.y)
			{
				if (link.curr_animation != 1)
					Set_Animation_BOB(&link,1);

				//Move link North
				if(!Collision_BOBS(&slime,&link))
				{
					link.y-=link_speed;
					dx = 0; 
					dy = -link_speed;
				}
			}
		}
		else
		{
			if (slime.y > link.y)
			{
				if(!Collision_BOBS(&slime,&link))
				{
					link.y+=link_speed;
					dx = 0; 
					dy = link_speed;
				}
			}
			else if (slime.y < link.y)
			{
				if(!Collision_BOBS(&slime,&link))
				{
					link.y-=link_speed;
					dx = 0; 
					dy = -link_speed;
				}
			}

			else if (slime.x > link.x)
			{
				if(!Collision_BOBS(&slime,&link))
				{
					link.x+=link_speed;
					dx = link_speed; 
					dy = 0;
				}
			}
			else if (slime.x < link.x)
			{
				if(!Collision_BOBS(&slime,&link))
				{
					link.x-=link_speed;
					dx = -link_speed; 
					dy = 0;
				}		
			}

		}
			
		//Check to see if link was hit by player attack
		if(linkNotHit)
		{
			linkNotHit = false;
			linkHitCount = Get_Clock();
			if(Collision_BOBS(&weaponeast,&link))
			{
				linkHit = true;
			}
			if(Collision_BOBS(&weaponwest,&link))
			{
				linkHit = true;
			}
			if(Collision_BOBS(&weaponnorth,&link))
			{
				linkHit = true;
			}
			if(Collision_BOBS(&weaponsouth,&link))
			{
				linkHit = true;
			}
		}

		if(Get_Clock() > (linkHitCount + 120))
			linkNotHit = true;

		if(linkHit)
		{
			linkHealth--;
			DSound_Play(guard_die_id, 0);
			if(link.curr_animation == 0)
			{
				link.x-=50;
				dx=-50; dy=0;
			}
			else if(link.curr_animation == 2)
			{
				link.x+=50;
				dx=+50; dy=0;
			}
			else if(link.curr_animation == 1)
			{
				link.y+=50;
				dx=0; dy=+50;
			}
			else if(link.curr_animation == 3)
			{
				link.y-=50;
				dx=0; dy=-50;
			}
		}

		if(linkHealth == 0)
		{
			link_active = 0;
			Set_Pos_BOB(&link, -100,-100);
			IsEnding = 1;
		}
		Animate_BOB(&link);

		DDraw_Lock_Back_Surface();
			if (Color_Scan16(link.x+16, link.y+16,
                    link.x+link.width-16, link.y+link.height-3,                                    
                    RGB16Bit(1, 1, 1),
                    RGB16Bit(1, 1, 1), back_buffer,back_lpitch))
      {
      // back the link up along its last trajectory
		  link.x = link.x - dx;
		  link.y = link.y - dy;
      } // end if
		DDraw_Unlock_Back_Surface();
		Draw_BOB16(&link, lpddsback);
	}
}





//////////////////////////////////////////////////////////

int Game_Main(void *parms, int num_parms)
{
int index;             // looping var
int dx = 0;
int dy = 0;

 
static int   player_moving = 0; // tracks player motion
static int	player_attacked = 0;

// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE))
    PostMessage(main_window_handle, WM_DESTROY,0,0);



// start the timing clock
Start_Clock();

// clear the drawing surface
DDraw_Fill_Surface(lpddsback, 0);

// lock the back buffer
DDraw_Lock_Back_Surface();

if(IsIntro)
{
	Draw_Bitmap16(&intro, back_buffer, back_lpitch, 0);
	DDraw_Unlock_Back_Surface();
	lpdikey->GetDeviceState(256, (LPVOID)keyboard_state);
	if(intro_played)
	{
		DMusic_Play(intro_music_id);
		intro_played = 0;
		lvl1_played = 1;
	}
}
else if(IsStory)
{
    Draw_Bitmap16(&story, back_buffer, back_lpitch, 0);	
	DDraw_Unlock_Back_Surface();
	lpdikey->GetDeviceState(256, (LPVOID)keyboard_state);
}
else if(IsStory2)
{
	Draw_Bitmap16(&story2, back_buffer, back_lpitch, 0);
	DDraw_Unlock_Back_Surface();
	lpdikey->GetDeviceState(256, (LPVOID)keyboard_state);
}
else if(IsStory3)
{
	Draw_Bitmap16(&story3, back_buffer, back_lpitch, 0);
	DDraw_Unlock_Back_Surface();
	lpdikey->GetDeviceState(256, (LPVOID)keyboard_state);
}
else if(health <= 0)
{
	if(death_played)
	{
		DMusic_Stop(lvl1_music_id);
		DMusic_Play(death_music_id);
		death_played = 0;
	}
	Draw_Bitmap16(&death, back_buffer, back_lpitch, 0);
	DDraw_Unlock_Back_Surface();
	lpdikey->GetDeviceState(256, (LPVOID)keyboard_state);
}
else if(IsEnding)
{
	if(win_played)
	{
		DMusic_Stop(story3_music_id);
		DMusic_Play(win_music_id);
		win_played = 0;
	}
	Draw_Bitmap16(&ending, back_buffer, back_lpitch, 0);
	DDraw_Unlock_Back_Surface();
	lpdikey->GetDeviceState(256, (LPVOID)keyboard_state);
}
else
{
	if(lvl1_played)
	{
		DMusic_Stop(intro_music_id);
		DMusic_Play(lvl1_music_id);
		lvl1_played = 0;
		win_played = 1;
		death_played = 1;
	}

	if(room == 1)
	{
		// draw room 1
		Draw_Bitmap16(&r1, back_buffer, back_lpitch, 0);

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();
		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
		}
	}
	else if(room == 2)
	{
		// draw room 2
		Draw_Bitmap16(&r2, back_buffer, back_lpitch, 0);	

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
		}
	}
	else if(room == 3)
	{
		// draw room 3
		Draw_Bitmap16(&r3, back_buffer, back_lpitch, 0);

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
		}
	}
	else if(room == 4)
	{
		// draw room 4
		Draw_Bitmap16(&r4, back_buffer, back_lpitch, 0);

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
		}
	}
	else if(room == 5)
	{
		// draw room 5
		Draw_Bitmap16(&r5, back_buffer, back_lpitch, 0);	

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
		}
	}
	else if(room == 6)
	{
		// draw room 6
		Draw_Bitmap16(&r6, back_buffer, back_lpitch, 0);	

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
		}
	}
	else if(room == 7)
	{
		// draw room 7
		Draw_Bitmap16(&r7, back_buffer, back_lpitch, 0);	

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
			if(aliveFlag[room][0][0])
			{
				guard_active[0] = 1;
				Set_Pos_BOB(&guard[0], 516,74);
			}
			if(aliveFlag[room][0][1])
			{
				guard_active[1] = 1;
				Set_Pos_BOB(&guard[1], 216,126);
			}
			if(aliveFlag[room][0][2])
			{
				guard_active[2] = 1;
				Set_Pos_BOB(&guard[2], 348,134);
			}
			if(aliveFlag[room][0][3])
			{
				guard_active[3] = 1;
				Set_Pos_BOB(&guard[3], 60,194);
			}
			if(aliveFlag[room][0][4])
			{
				guard_active[4] = 1;
				Set_Pos_BOB(&guard[4], 400,210);
			}
			if(aliveFlag[room][0][5])
			{
				guard_active[5] = 1;
				Set_Pos_BOB(&guard[5], 52,370);
			}
		}
	}
	else if(room == 8)
	{
		// draw room 8
		Draw_Bitmap16(&r8, back_buffer, back_lpitch, 0);

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
		
			if(aliveFlag[room][0][0])
			{
				guard_active[0] = 1;
				Set_Pos_BOB(&guard[0], 243,74);
			}
			if(aliveFlag[room][0][1])
			{
				guard_active[1] = 1;
				Set_Pos_BOB(&guard[1], 243,150);
			}
			if(aliveFlag[room][0][2])
			{
				guard_active[2] = 1;
				Set_Pos_BOB(&guard[2], 243,202);
			}
			if(aliveFlag[room][0][3])
			{
				guard_active[3] = 1;
				Set_Pos_BOB(&guard[3], 243,310);
			}
			if(aliveFlag[room][0][4])
			{
				guard_active[4] = 1;
				Set_Pos_BOB(&guard[4], 243,374);
			}
			if(aliveFlag[room][0][5])
			{
				guard_active[5] = 1;
				Set_Pos_BOB(&guard[5], 323,74);
			}
			if(aliveFlag[room][0][6])
			{
				guard_active[6] = 1;
				Set_Pos_BOB(&guard[6], 323,150);
			}
			if(aliveFlag[room][0][7])
			{
				guard_active[7] = 1;
				Set_Pos_BOB(&guard[7], 323,202);
			}
			if(aliveFlag[room][0][8])
			{
				guard_active[8] = 1;
				Set_Pos_BOB(&guard[8], 323,310);
			}
			if(aliveFlag[room][0][9])
			{
				guard_active[9] = 1;
				Set_Pos_BOB(&guard[9], 323,374);
			}
		}
	}
	else if(room == 9)
	{
		// draw room 9
		Draw_Bitmap16(&r9, back_buffer, back_lpitch, 0);

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
			if(aliveFlag[room][0][0])
			{
				guard_active[0] = 1;
				Set_Pos_BOB(&guard[0], 171,82);
			}
			if(aliveFlag[room][0][1])
			{
				guard_active[1] = 1;
				Set_Pos_BOB(&guard[1], 259,82);
			}
			if(aliveFlag[room][0][2])
			{
				guard_active[2] = 1;
				Set_Pos_BOB(&guard[2], 511,98);
			}
			if(aliveFlag[room][0][3])
			{
				guard_active[3] = 1;
				Set_Pos_BOB(&guard[3], 291,202);
			}
			if(aliveFlag[room][0][4])
			{
				guard_active[4] = 1;
				Set_Pos_BOB(&guard[4], 519,366);
			}
		}
	}
	else if(room == 10)
	{
		// draw room 10
		Draw_Bitmap16(&r10, back_buffer, back_lpitch, 0);

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
			if(aliveFlag[room][0][0])
			{
				guard_active[0] = 1;
				Set_Pos_BOB(&guard[0], 212,142);
			}
			if(aliveFlag[room][0][1])
			{
				guard_active[1] = 1;
				Set_Pos_BOB(&guard[1], 212,274);
			}
			if(aliveFlag[room][0][2])
			{
				guard_active[2] = 1;
				Set_Pos_BOB(&guard[2], 292,210);
			}
			if(aliveFlag[room][0][3])
			{
				guard_active[3] = 1;
				Set_Pos_BOB(&guard[3], 392,142);
			}
			if(aliveFlag[room][0][4])
			{
				guard_active[4] = 1;
				Set_Pos_BOB(&guard[4], 392,274);
			}
		}
	}
	else if(room == 11)
	{
		// draw room 11
		Draw_Bitmap16(&r11, back_buffer, back_lpitch, 0);

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
			if(aliveFlag[room][0][0])
			{
				guard_active[0] = 1;
				Set_Pos_BOB(&guard[0], 147,107);
			}
			if(aliveFlag[room][0][1])
			{
				guard_active[1] = 1;
				Set_Pos_BOB(&guard[1], 147,215);
			}
			if(aliveFlag[room][0][2])
			{
				guard_active[2] = 1;
				Set_Pos_BOB(&guard[2], 147,347);
			}
			if(aliveFlag[room][0][3])
			{
				guard_active[3] = 1;
				Set_Pos_BOB(&guard[3], 403,107);
			}
			if(aliveFlag[room][0][4])
			{
				guard_active[4] = 1;
				Set_Pos_BOB(&guard[4], 403,215);
			}
			if(aliveFlag[room][0][5])
			{
				guard_active[5] = 1;
				Set_Pos_BOB(&guard[5], 402,347);
			}
			if(aliveFlag[room][0][6])
			{
				guard_active[6] = 1;
				Set_Pos_BOB(&guard[6], 223,167);
			}
			if(aliveFlag[room][0][7])
			{
				guard_active[7] = 1;
				Set_Pos_BOB(&guard[7], 223,259);
			}
			if(aliveFlag[room][0][8])
			{
				guard_active[8] = 1;
				Set_Pos_BOB(&guard[8], 351,167);
			}
			if(aliveFlag[room][0][9])
			{
				guard_active[9] = 1;
				Set_Pos_BOB(&guard[9], 351,259);
			}
		}
	}
	else if(room == 12)
	{
		// draw room 12
		Draw_Bitmap16(&r12, back_buffer, back_lpitch, 0);

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
			if(aliveFlag[room][0][0])
			{
				guard_active[0] = 1;
				Set_Pos_BOB(&guard[0], 64,88);
			}
			if(aliveFlag[room][0][1])
			{
				guard_active[1] = 1;
				Set_Pos_BOB(&guard[1], 64,256);
			}
			if(aliveFlag[room][0][2])
			{
				guard_active[2] = 1;
				Set_Pos_BOB(&guard[2], 212,184);
			}
			if(aliveFlag[room][0][3])
			{
				guard_active[3] = 1;
				Set_Pos_BOB(&guard[3], 412,132);
			}
			if(aliveFlag[room][0][4])
			{
				guard_active[4] = 1;
				Set_Pos_BOB(&guard[4], 492,352);
			}
		}
	}
	else if(room == 13)
	{
		// draw room 13
		Draw_Bitmap16(&r13, back_buffer, back_lpitch, 0);

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
			if(aliveFlag[room][0][0])
			{
				guard_active[0] = 1;
				Set_Pos_BOB(&guard[0], 247,95);
			}
			if(aliveFlag[room][0][1])
			{
				guard_active[1] = 1;
				Set_Pos_BOB(&guard[1], 227,183);
			}
			if(aliveFlag[room][0][2])
			{
				guard_active[2] = 1;
				Set_Pos_BOB(&guard[2], 315,95);
			}
			if(aliveFlag[room][0][3])
			{
				guard_active[3] = 1;
				Set_Pos_BOB(&guard[3], 347,183);
			}
		}
	}
	else if(room == 14)
	{
		// draw room 14
		Draw_Bitmap16(&r14, back_buffer, back_lpitch, 0);

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
			if(aliveFlag[room][0][0])
			{
				guard_active[0] = 1;
				Set_Pos_BOB(&guard[0], 47,363);
			}
			if(aliveFlag[room][0][1])
			{
				guard_active[1] = 1;
				Set_Pos_BOB(&guard[1], 203,215);
			}
			if(aliveFlag[room][0][2])
			{
				guard_active[2] = 1;
				Set_Pos_BOB(&guard[2], 307,215);
			}
			if(aliveFlag[room][0][3])
			{
				guard_active[3] = 1;
				Set_Pos_BOB(&guard[3], 483,343);
			}
			if(aliveFlag[room][0][4])
			{
				guard_active[4] = 1;
				Set_Pos_BOB(&guard[4], 495,95);
			}
		}
	}
	else if(room == 15)
	{
		// draw room 14
		Draw_Bitmap16(&r15, back_buffer, back_lpitch, 0);

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if(firstTime)
		{
			//set up room each time player enters it
			firstTime = false;
			link_active = 1;
			Set_Pos_BOB(&link, 300,100);
		}
	}

	if(monsters_killed == 50 && loadRoom13b)
	{
		loadRoom13b = false;
		Load_Bitmap_File(&bitmap16bit, "DEBUG/2/13b.BMP");
		Create_Bitmap(&r13, 0,0, 640, 480,16);
		Load_Image_Bitmap16(&r13,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
		Unload_Bitmap_File(&bitmap16bit);
	}
	// get player input
	// get the keyboard data
	lpdikey->GetDeviceState(256, (LPVOID)keyboard_state);

	// reset motion flag
	player_moving = 0;

	guard_AI();
	link_AI();

	if (keyboard_state[DIK_RIGHT]) 
	{
		// move slime
		slime.x+=4;
		dx=+4; dy=0;

		// set motion flag
		player_moving = 1;

		// check animation needs to change
		if (slime.curr_animation != SLIME_EAST)
			Set_Animation_BOB(&slime,SLIME_EAST);
	} // end if
	else if (keyboard_state[DIK_LEFT])  
	{
		// move slime
		slime.x-=4;
		dx=-4; dy=0; 
   
		// set motion flag
		player_moving = 1;

		// check animation needs to change
		if (slime.curr_animation != SLIME_WEST)
			Set_Animation_BOB(&slime,SLIME_WEST);

	} // end if
	else if (keyboard_state[DIK_UP])    
	{
		// move slime
		slime.y-=4;
		dx=0; dy=-4;
   
		// set motion flag
		player_moving = 1;

		// check animation needs to change
		if (slime.curr_animation != SLIME_NORTH)
			Set_Animation_BOB(&slime,SLIME_NORTH);

	} // end if
	else if (keyboard_state[DIK_DOWN])  
	{
		// move slime
		slime.y+=4;
		dx=0; dy=+4;

		// set motion flag
		player_moving = 1;

		// check animation needs to change
		if (slime.curr_animation != SLIME_SOUTH)
			Set_Animation_BOB(&slime,SLIME_SOUTH);
	
	} // end if
	else if(keyboard_state[DIK_SPACE] && player_attacked == 0)
	{
	//attack slime
		if(slime.curr_animation == SLIME_EAST)
			Set_Animation_BOB(&slime,SLIME_AEAST);
		else if (slime.curr_animation == SLIME_WEST)
			Set_Animation_BOB(&slime,SLIME_AWEST);
		else if (slime.curr_animation == SLIME_NORTH)
			Set_Animation_BOB(&slime,SLIME_ANORTH);
		else if (slime.curr_animation == SLIME_SOUTH)
			Set_Animation_BOB(&slime,SLIME_ASOUTH);		
	}


	if(slime.curr_animation == SLIME_AEAST)
	{
		Animate_BOB(&slime);
		Draw_BOB(&slime, lpddsback);
		Set_Pos_BOB(&weaponeast,slime.x+64,slime.y+33);
		Draw_BOB(&weaponeast, lpddsback);
		Show_BOB(&weaponeast);
		if(player_attacked == 0)
		{
			DSound_Play(slime_attack_id, 0);
			attackCount = Get_Clock();
		}
		player_attacked = 1;
	}
	else if(slime.curr_animation == SLIME_AWEST)
	{
		Animate_BOB(&slime);
		Set_Pos_BOB(&weaponwest,slime.x-30,slime.y+33);
		Draw_BOB16(&weaponwest, lpddsback);
		Show_BOB(&weaponwest);
		if(player_attacked == 0)
		{
			DSound_Play(slime_attack_id, 0);
			attackCount = Get_Clock();
		}
		player_attacked = 1;
	}
	else if(slime.curr_animation == SLIME_ANORTH)
	{
		Animate_BOB(&slime);
		Draw_BOB16(&slime, lpddsback);
		Set_Pos_BOB(&weaponnorth,slime.x+28,slime.y-32);
		Draw_BOB16(&weaponnorth, lpddsback);
		Show_BOB(&weaponnorth);
		if(player_attacked == 0)
		{
			DSound_Play(slime_attack_id, 0);
			attackCount = Get_Clock();
		}
		player_attacked = 1;
	}
	else if(slime.curr_animation == SLIME_ASOUTH)
	{
		Animate_BOB(&slime);
		Set_Pos_BOB(&weaponsouth,slime.x+30,slime.y+63);
		Draw_BOB16(&weaponsouth, lpddsback);
		Show_BOB(&weaponsouth);
		if(player_attacked == 0)
		{
			DSound_Play(slime_attack_id, 0);
			attackCount = Get_Clock();
		}
		player_attacked = 1;
	}


	if(Get_Clock() > (attackCount + 120) && player_attacked == 1)
	{
		if(slime.curr_animation == SLIME_AEAST || slime.curr_animation == SLIME_EAST)
		{
			Set_Pos_BOB(&weaponeast, -200, -200);
			Hide_BOB(&weaponeast);
			Set_Animation_BOB(&slime,SLIME_SEAST);
			slime.curr_frame = 0;
			Animate_BOB(&slime);
			Set_Animation_BOB(&slime,SLIME_EAST);
			if(!keyboard_state[DIK_SPACE])
				player_attacked = 0;
		}
		else if(slime.curr_animation == SLIME_AWEST || slime.curr_animation == SLIME_WEST)
		{
			Set_Pos_BOB(&weaponwest, -200, -200);
			Hide_BOB(&weaponwest);
			Set_Animation_BOB(&slime,SLIME_SWEST);
			slime.curr_frame = 0+8;
			Animate_BOB(&slime);
			Set_Animation_BOB(&slime,SLIME_WEST);
			if(!keyboard_state[DIK_SPACE])
				player_attacked = 0;
		}
		else if(slime.curr_animation == SLIME_ANORTH || slime.curr_animation == SLIME_NORTH)
		{
			Set_Pos_BOB(&weaponnorth, -200, -200);
			Hide_BOB(&weaponnorth);
			Set_Animation_BOB(&slime,SLIME_SNORTH);
			slime.curr_frame = 0+4;
			Animate_BOB(&slime);
			Set_Animation_BOB(&slime,SLIME_NORTH);
			if(!keyboard_state[DIK_SPACE])
				player_attacked = 0;
		}
		else if(slime.curr_animation == SLIME_ASOUTH || slime.curr_animation == SLIME_SOUTH)
		{
			Set_Pos_BOB(&weaponsouth, -200, -200);
			Hide_BOB(&weaponsouth);
			Set_Animation_BOB(&slime,SLIME_SSOUTH);
			slime.curr_frame = 0+12;
			Animate_BOB(&slime);
			Set_Animation_BOB(&slime,SLIME_SOUTH);
			if(!keyboard_state[DIK_SPACE])
				player_attacked = 0;
		}
	}


	for(index = 0; index < MAX_GUARDS; index++)
	{
		if(Collision_BOBS(&slime,&guard[index]))
		{
			if(notHit)
			{
				notHit = false;
				playerHitCount = Get_Clock();
				if(slime.curr_animation == SLIME_EAST)
				{
					slime.x-=50;
					dx=-50; dy=0;
					player_moving = 1;
					DSound_Play(slime_hit_id, 0);
				}
				else if(slime.curr_animation == SLIME_WEST)
				{
					slime.x+=50;
					dx=+50; dy=0;
					player_moving = 1;
					DSound_Play(slime_hit_id, 0);
				}
				else if(slime.curr_animation == SLIME_NORTH)
				{
					slime.y+=50;
					dx=0; dy=+50;
					player_moving = 1;
					DSound_Play(slime_hit_id, 0);
				}
				else if(slime.curr_animation == SLIME_SOUTH)
				{
					slime.y-=50;
					dx=0; dy=-50;
					player_moving = 1;
					DSound_Play(slime_hit_id, 0);
				}
				health = health-5;
			}
			else
			{
				slime.x-=dx;
				slime.y-=dy;
			}
		}
	}

	if(Collision_BOBS(&slime,&link))
	{
		if(notHit)
		{
			notHit = false;
			playerHitCount = Get_Clock();
			if(slime.curr_animation == SLIME_EAST)
			{
				slime.x-=50;
				dx=-50; dy=0;
				player_moving = 1;
				DSound_Play(slime_hit_id, 0);
			}
			else if(slime.curr_animation == SLIME_WEST)
			{
				slime.x+=50;
				dx=+50; dy=0;
				player_moving = 1;
				DSound_Play(slime_hit_id, 0);
			}
			else if(slime.curr_animation == SLIME_NORTH)
			{
				slime.y+=50;
				dx=0; dy=+50;
				player_moving = 1;
				DSound_Play(slime_hit_id, 0);
			}
			else if(slime.curr_animation == SLIME_SOUTH)
			{
				slime.y-=50;
				dx=0; dy=-50;
				player_moving = 1;
				DSound_Play(slime_hit_id, 0);
			}
			health = health-10;
		}
		else
		{
			slime.x-=dx;
			slime.y-=dy;
		}
	}

	if(Get_Clock() > (playerHitCount + 1000))
		notHit = true;


	// only animate if player is moving
	if (player_moving)
	{
	// animate slime
   Animate_BOB(&slime);


   // see if slime hit a wall
   // lock surface, so we can scan it
   DDraw_Lock_Back_Surface();
	if (Color_Scan16(slime.x+16, slime.y+16,
                    slime.x+slime.width-16, slime.y+slime.height-3,                                    
                    RGB16Bit(1, 1, 1),
                    RGB16Bit(1, 1, 1), back_buffer,back_lpitch))
      {
      // back the slime up along its last trajectory
      slime.x-=dx;
      slime.y-=dy;
      } // end if

	if (Color_Scan16(slime.x+16, slime.y+16,
                    slime.x+slime.width-16, slime.y+slime.height-3,                                    
                    RGB16Bit(111, 19, 64),
                    RGB16Bit(1, 1, 1), back_buffer,back_lpitch) && room == 3)
      {
		  IsStory2 = 1;
		  firstTime = true;
		  DMusic_Stop(lvl1_music_id);
		  DMusic_Play(story2_music_id);

		  Set_Pos_BOB(&slime, 280, 375);		
		  for(int i = 0; i < MAX_GUARDS; i++)		
		  {
			  guard_active[i] = 0;
			  Set_Pos_BOB(&guard[i], -100,-100);
		  }
		  link_active = 0;
		  Set_Pos_BOB(&link, -100,-100);
      }

	  if(notHit)
	  {
		//If player moves to north exit
		if(int(slime.y) < 30)
		{
			//LEVEL 1
			//****************************************
			if(room == 3)
			{
				room = 1;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 390);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 4)
			{
				room = 2;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 390);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 6)
			{
				room = 4;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 390);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 5)
			{
				room = 3;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 390);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}

			//LEVEL 2
			//****************************************
			else if(room == 10)
			{
				room = 7;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 390);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 12)
			{
				room = 10;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 390);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 11)
			{
				room = 9;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 390);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 14)
			{
				room = 11;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 390);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 13)
			{
				IsStory3 = 1;
				DMusic_Stop(lvl2_music_id);
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 390);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
		}
		//If player moves to East Exit
		if(int(slime.x) > 565)
		{
			//LEVEL 1
			//****************************************
			if(room == 1)
			{
				room = 2;
				firstTime = true;
				Set_Pos_BOB(&slime, 15, int(slime.y));
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 5)
			{
				room = 6;
				firstTime = true;
				Set_Pos_BOB(&slime, 15, int(slime.y));
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}

			//LEVEL 2
			//****************************************
			else if(room == 7)
			{
				room = 8;
				firstTime = true;
				Set_Pos_BOB(&slime, 15, int(slime.y));
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 8)
			{
				room = 9;
				firstTime = true;
				Set_Pos_BOB(&slime, 15, int(slime.y));
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 12)
			{
				room = 13;
				firstTime = true;
				Set_Pos_BOB(&slime, 15, int(slime.y));
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 13)
			{
				room = 14;
				firstTime = true;
				Set_Pos_BOB(&slime, 15, int(slime.y));
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
		}
		//If player moves to West Exit
		if(int(slime.x) < 10)
		{
			//LEVEL 1
			//****************************************
			if(room == 2)
			{
				room = 1;
				firstTime = true;
				Set_Pos_BOB(&slime, 560, int(slime.y));
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 6)
			{
				room = 5;
				firstTime = true;
				Set_Pos_BOB(&slime, 560, int(slime.y));
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}

			//LEVEL 2
			//****************************************
			else if(room == 8)
			{
				room = 7;
				firstTime = true;
				Set_Pos_BOB(&slime, 560, int(slime.y));
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 9)
			{
				room = 8;
				firstTime = true;
				Set_Pos_BOB(&slime, 560, int(slime.y));
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 13)
			{
				room = 12;
				firstTime = true;
				Set_Pos_BOB(&slime, 560, int(slime.y));
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 14)
			{
				room = 13;
				firstTime = true;
				Set_Pos_BOB(&slime, 560, int(slime.y));
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
		}
		//If player moves to South Exit
		if(int(slime.y) > 394)
		{
			//LEVEL 1
			//****************************************
			if(room == 1)
			{
				room = 3;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 35);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 2)
			{
				room = 4;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 35);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 4)
			{
				room = 6;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 35);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 3)
			{
				room = 5;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 35);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}

			//LEVEL 2
			//****************************************
			else if(room == 7)
			{
				room = 10;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 35);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 10)
			{
				room = 12;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 35);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 9)
			{
				room = 11;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 35);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
			else if(room == 11)
			{
				room = 14;
				firstTime = true;
				Set_Pos_BOB(&slime, int(slime.x), 35);
				for(int i = 0; i < MAX_GUARDS; i++)
				{
					guard_active[i] = 0;
					Set_Pos_BOB(&guard[i], -100,-100);
				}
				link_active = 0;
				Set_Pos_BOB(&link, -100,-100);
			}
		}
	  }
   
   // done, so unlock
   DDraw_Unlock_Back_Surface();

   // check if slime is off screen
   if (slime.x < 0 || slime.x > (screen_width - slime.width))
      slime.x-=dx;

   if (slime.y < 0 || slime.y > (screen_height - slime.height))
      slime.y-=dy;

   } // end if

// draw the slime
Draw_BOB16(&slime, lpddsback);

sprintf(buffer, "HEALTH: %d", health);

Draw_Text_GDI(buffer, 0, 0, RGB(255, 255, 255), lpddsback);
}
// flip the surfaces
DDraw_Flip();

// sync to 30 fps
Wait_Clock(30);
if(IsIntro)
{
	if(KEY_DOWN(VK_RETURN) || keyboard_state[DIK_RETURN])
	{
		IsIntro = 0;
		IsStory = 1;
	}
}
if(IsStory)
{
	if(KEY_DOWN(VK_SPACE) || keyboard_state[DIK_SPACE])
	{
		IsStory = 0;
	}
}
if(IsStory2)
{
	if(KEY_DOWN(VK_SPACE) || keyboard_state[DIK_SPACE])
	{
		IsStory2 = 0;
		room = 13;
		monsters_killed = 0;
		DMusic_Stop(story2_music_id);
		DMusic_Play(lvl2_music_id);
	}
}
if(IsStory3)
{
	if(KEY_DOWN(VK_SPACE) || keyboard_state[DIK_SPACE])
	{
		IsStory3 = 0;
		room = 15;
		DMusic_Play(story3_music_id);
	}
}
// return success
return(1);

} // end Game_Main

//////////////////////////////////////////////////////////